Index: /LMDZ4/trunk/arch/arch-PW6_VARGAS.fcm
===================================================================
--- /LMDZ4/trunk/arch/arch-PW6_VARGAS.fcm	(revision 1402)
+++ /LMDZ4/trunk/arch/arch-PW6_VARGAS.fcm	(revision 1403)
@@ -3,13 +3,13 @@
 %AR                  ar
 %MAKE                gmake
-%FPP_FLAGS           -P
-%FPP_DEF             NC_DOUBLE BLAS SGEMV=DGEMV SGEMM=DGEMM
-%BASE_FFLAGS         -qautodbl=dbl4 -qxlf90=autodealloc -qextname=flush
+%FPP_FLAGS           -P -I/usr/local/pub/FFTW/3.2/include
+%FPP_DEF             NC_DOUBLE BLAS SGEMV=DGEMV SGEMM=DGEMM FFT_FFTW
+%BASE_FFLAGS         -qautodbl=dbl4 -qxlf90=autodealloc -qmaxmem=-1 -qzerosize
 %PROD_FFLAGS         -O5
 %DEV_FFLAGS          -O2 -qfullpath -qinitauto=7FBFFFFF -qfloat=nans -qflttrap=overflow:zerodivide:invalid:enable -qsigtrap
-%DEBUG_FFLAGS        -g -qfullpath -qnooptimize -qinitauto=7FBFFFFF  -qfloat=nans -qflttrap=overflow:zerodivide:invalid:enable -qsigtrap 
+%DEBUG_FFLAGS        -g -qfullpath -qnooptimize -qinitauto=7FBFFFFF  -qfloat=nans -qflttrap=overflow:zerodivide:invalid:enable -qsigtrap -qcheck -qextchk
 %MPI_FFLAGS          -I/usr/lpp/ppe.poe/include/thread64
 %OMP_FFLAGS          -qsmp=omp
-%BASE_LD             -lessl
+%BASE_LD             -lessl -L/usr/local/pub/FFTW/3.2/lib -lfftw3
 %MPI_LD              
 %OMP_LD              -qsmp=omp
Index: /LMDZ4/trunk/create_make_gcm
===================================================================
--- /LMDZ4/trunk/create_make_gcm	(revision 1402)
+++ /LMDZ4/trunk/create_make_gcm	(revision 1403)
@@ -108,5 +108,5 @@
 echo '	cd $(LIBO) ; $(RANLIB) lib*.a ; cd $(GCM) ;\'
 echo '	cd $(LOCAL_DIR); \'
-echo '	$(COMPILE90) $(LIBF)/$(DIRMAIN)/$(PROG).F -o $(PROG).o ; \'
+echo '	$(COMPILE90) $(LIBF)/$(DIRMAIN)/$(SOURCE) -o $(PROG).o ; \'
 echo '	$(LINK) $(PROG).o -L$(LIBO) $(L_DYN) $(L_ADJNT) $(L_COSP) $(L_FILTRE) $(L_PHY) $(L_DYN) $(L_BIBIO) $(L_DYN) $(OPLINK) $(OPTION_LINK) -o $(LOCAL_DIR)/$(PROG).e ; $(RM) $(PROG).o '
 echo
Index: /LMDZ4/trunk/gcm.def
===================================================================
--- /LMDZ4/trunk/gcm.def	(revision 1402)
+++ /LMDZ4/trunk/gcm.def	(revision 1403)
@@ -1,6 +1,4 @@
-#
 ## $Id$
-#
-## nombre de pas par jour (multiple de iperiod)
+## nombre de pas par jour (multiple de iperiod) ( ici pour  dt = 1 min )      
 day_step=480
 ## periode pour le pas Matsuno (en pas)
@@ -11,5 +9,5 @@
 lstardis=y
 ## nombre d'iterations de l'operateur de dissipation   gradiv
-nitergdiv=2
+nitergdiv=1
 ## nombre d'iterations de l'operateur de dissipation  nxgradrot
 nitergrot=2
@@ -17,17 +15,30 @@
 niterh=2
 ## temps de dissipation des plus petites long.d ondes pour u,v (gradiv)  
-tetagdiv=10800.
+tetagdiv=5400.
 ## temps de dissipation des plus petites long.d ondes pour u,v(nxgradrot)
-tetagrot=18000.
+tetagrot=5400.
 ## temps de dissipation des plus petites long.d ondes pour  h ( divgrad) 
-tetatemp=18000.
+tetatemp=5400.
 ## coefficient pour gamdissip                                            
 coefdis=0.
-## choix du shema d'integration temporelle (Matsuno ou Matsuno-leapfrog) 
+## choix du shema d'integration temporelle (Matsuno:y ou Matsuno-leapfrog:n) 
 purmats=n
-## physics type (0: none 1: phylmd,... 2: newtonian)
+## avec ou sans physique
+## 0: pas de physique (e.g. en mode Shallow Water)
+## 1: avec physique (e.g. physique phylmd)
+## 2: avec rappel newtonien dans la dynamique                                         
 iflag_phys=1
-## periode de la physique (en pas)                                       
+## avec ou sans fichiers de demarrage (start.nc, startphy.nc) ?
+## (sans fichiers de demarrage, initialisation des champs par iniacademic
+##  dans la dynamique)
+read_start=y
+## periode de la physique (en pas dynamiques, n'a de sens que si iflag_phys=1)                                       
 iphysiq=10
+##  Avec ou sans strato
+ok_strato=n 
+#  Couche eponge dans les couches de pression plus faible que 100 fois la pression de la derniere couche
+iflag_top_bound=2
+#  Coefficient pour la couche eponge (valeur derniere couche)
+tau_top_bound=5.e-5
 ## longitude en degres du centre du zoom                                 
 clon=0.
Index: /LMDZ4/trunk/libf/bibio/initdynav.F
===================================================================
--- /LMDZ4/trunk/libf/bibio/initdynav.F	(revision 1402)
+++ /LMDZ4/trunk/libf/bibio/initdynav.F	(revision 1403)
@@ -2,6 +2,5 @@
 ! $Id$
 !
-      subroutine initdynav(infile,day0,anne0,tstep,t_ops,t_wrt
-     .                     ,fileid)
+      subroutine initdynav(day0,anne0,tstep,t_ops,t_wrt)
 
 #ifdef CPP_IOIPSL
@@ -9,5 +8,6 @@
 #endif
        USE infotrac, ONLY : nqtot, ttext
-
+      use com_io_dyn_mod, only : histaveid,histvaveid,histuaveid,       &
+     &        dynhistave_file,dynhistvave_file,dynhistuave_file
       implicit none
 
@@ -30,6 +30,4 @@
 C      t_wrt: frequence d'ecriture sur le fichier
 C
-C   Sortie:
-C      fileid: ID du fichier netcdf cree
 C
 C   L. Fairhead, LMD, 03/99
@@ -52,8 +50,6 @@
 C   Arguments
 C
-      character*(*) infile
       integer day0, anne0
       real tstep, t_ops, t_wrt
-      integer fileid
 
 #ifdef CPP_IOIPSL
@@ -61,9 +57,9 @@
 C   Variables locales
 C
-      integer thoriid, zvertiid
       integer tau0
       real zjulian
       integer iq
       real rlong(iip1,jjp1), rlat(iip1,jjp1)
+      integer uhoriid, vhoriid, thoriid, zvertiid
       integer ii,jj
       integer zan, dayref
@@ -88,13 +84,45 @@
       enddo
        
-      call histbeg(infile, iip1, rlong(:,1), jjp1, rlat(1,:),
+! Creation de 3 fichiers pour les differentes grilles horizontales
+! Restriction de IOIPSL: seulement 2 coordonnees dans le meme fichier
+! Grille Scalaire       
+      call histbeg(dynhistave_file, iip1, rlong(:,1), jjp1, rlat(1,:),
      .             1, iip1, 1, jjp1,
-     .             tau0, zjulian, tstep, thoriid, fileid)
-
+     .             tau0, zjulian, tstep, thoriid,histaveid)
+
+C  Creation du fichier histoire pour les grilles en V et U (oblige pour l'instant,
+C  IOIPSL ne permet pas de grilles avec des nombres de point differents dans
+C  un meme fichier)
+! Grille V
+      do jj = 1, jjm
+        do ii = 1, iip1
+          rlong(ii,jj) = rlonv(ii) * 180. / pi
+          rlat(ii,jj) = rlatv(jj) * 180. / pi
+        enddo
+      enddo
+
+      call histbeg(dynhistvave_file, iip1, rlong(:,1), jjm, rlat(1,:),
+     .             1, iip1, 1, jjm,
+     .             tau0, zjulian, tstep, vhoriid,histvaveid)
+! Grille U
+      do jj = 1, jjp1
+        do ii = 1, iip1
+          rlong(ii,jj) = rlonu(ii) * 180. / pi
+          rlat(ii,jj) = rlatu(jj) * 180. / pi
+        enddo
+      enddo
+
+      call histbeg(dynhistuave_file, iip1, rlong(:,1),jjp1, rlat(1,:),
+     .             1, iip1, 1, jjp1,
+     .             tau0, zjulian, tstep, uhoriid,histuaveid)
 C
 C  Appel a histvert pour la grille verticale
 C
-      call histvert(fileid, 'sigss', 'Niveaux sigma','Pa',
-     .              llm, nivsigs, zvertiid)
+      call histvert(histaveid,'presnivs','Niveaux Pression
+     &     approximatifs','mb',llm, presnivs/100., zvertiid,'down')
+      call histvert(histuaveid,'presnivs','Niveaux Pression
+     &     approximatifs','mb',llm, presnivs/100., zvertiid,'down')
+      call histvert(histvaveid,'presnivs','Niveaux Pression
+     &     approximatifs','mb',llm, presnivs/100., zvertiid,'down')
 C
 C  Appels a histdef pour la definition des variables a sauvegarder
@@ -102,14 +130,13 @@
 C  Vents U
 C
-      write(6,*)'inithistave',tstep
-      call histdef(fileid, 'u', 'vents u scalaires moyennes',
-     .             'm/s', iip1, jjp1, thoriid, llm, 1, llm, zvertiid,
-     .             32, 'ave(X)', t_ops, t_wrt)
-
-C
+!      write(6,*)'inithistave',tstep
+      call histdef(histuaveid, 'u', 'vent u moyen ',
+     .             'm/s', iip1, jjp1, uhoriid, llm, 1, llm, zvertiid,
+     .             32, 'ave(X)', t_ops, t_wrt)
+
 C  Vents V
 C
-      call histdef(fileid, 'v', 'vents v scalaires moyennes',
-     .             'm/s', iip1, jjp1, thoriid, llm, 1, llm, zvertiid,
+      call histdef(histvaveid, 'v', 'vent v moyen',
+     .             'm/s', iip1, jjm, vhoriid, llm, 1, llm, zvertiid,
      .             32, 'ave(X)', t_ops, t_wrt)
 
@@ -117,5 +144,5 @@
 C  Temperature
 C
-      call histdef(fileid, 'temp', 'temperature moyennee', 'K',
+      call histdef(histaveid, 'temp', 'temperature moyenne', 'K',
      .             iip1, jjp1, thoriid, llm, 1, llm, zvertiid,
      .             32, 'ave(X)', t_ops, t_wrt)
@@ -123,13 +150,11 @@
 C  Temperature potentielle
 C
-      call histdef(fileid, 'theta', 'temperature potentielle', 'K',
-     .             iip1, jjp1, thoriid, llm, 1, llm, zvertiid,
-     .             32, 'ave(X)', t_ops, t_wrt)
-
-
+      call histdef(histaveid, 'theta', 'temperature potentielle', 'K',
+     .             iip1, jjp1, thoriid, llm, 1, llm, zvertiid,
+     .             32, 'ave(X)', t_ops, t_wrt)
 C
 C  Geopotentiel
 C
-      call histdef(fileid, 'phi', 'geopotentiel moyenne', '-',
+      call histdef(histaveid, 'phi', 'geopotentiel moyen', '-',
      .             iip1, jjp1, thoriid, llm, 1, llm, zvertiid,
      .             32, 'ave(X)', t_ops, t_wrt)
@@ -137,31 +162,33 @@
 C  Traceurs
 C
-        DO iq=1,nqtot
-          call histdef(fileid, ttext(iq), ttext(iq), '-',
-     .             iip1, jjp1, thoriid, llm, 1, llm, zvertiid,
-     .             32, 'ave(X)', t_ops, t_wrt)
-        enddo
+!        DO iq=1,nqtot
+!          call histdef(histaveid, ttext(iq), ttext(iq), '-',
+!     .             iip1, jjp1, thoriid, llm, 1, llm, zvertiid,
+!     .             32, 'ave(X)', t_ops, t_wrt)
+!        enddo
 C
 C  Masse
 C
-      call histdef(fileid, 'masse', 'masse', 'kg',
+      call histdef(histaveid, 'masse', 'masse', 'kg',
+     .             iip1, jjp1, thoriid, llm, 1, llm, zvertiid,
+     .             32, 'ave(X)', t_ops, t_wrt)
+C
+C  Pression au sol
+C
+      call histdef(histaveid, 'ps', 'pression naturelle au sol', 'Pa',
      .             iip1, jjp1, thoriid, 1, 1, 1, -99,
      .             32, 'ave(X)', t_ops, t_wrt)
 C
-C  Pression au sol
-C
-      call histdef(fileid, 'ps', 'pression naturelle au sol', 'Pa',
-     .             iip1, jjp1, thoriid, 1, 1, 1, -99,
-     .             32, 'ave(X)', t_ops, t_wrt)
-C
-C  Pression au sol
-C
-      call histdef(fileid, 'phis', 'geopotentiel au sol', '-',
-     .             iip1, jjp1, thoriid, 1, 1, 1, -99,
-     .             32, 'ave(X)', t_ops, t_wrt)
-C
+C  Geopotentiel au sol
+C
+!      call histdef(histaveid, 'phis', 'geopotentiel au sol', '-',
+!     .             iip1, jjp1, thoriid, 1, 1, 1, -99,
+!     .             32, 'ave(X)', t_ops, t_wrt)
+!C
 C  Fin
 C
-      call histend(fileid)
+      call histend(histaveid)
+      call histend(histuaveid)
+      call histend(histvaveid)
 #else
 ! tell the user this routine should be run with ioipsl
Index: /LMDZ4/trunk/libf/bibio/inithist.F
===================================================================
--- /LMDZ4/trunk/libf/bibio/inithist.F	(revision 1402)
+++ /LMDZ4/trunk/libf/bibio/inithist.F	(revision 1403)
@@ -2,6 +2,5 @@
 ! $Id$
 !
-      subroutine inithist(infile,day0,anne0,tstep,t_ops,t_wrt,fileid,
-     .                    filevid)
+      subroutine inithist(day0,anne0,tstep,t_ops,t_wrt)
 
 #ifdef CPP_IOIPSL
@@ -9,4 +8,6 @@
 #endif
        USE infotrac, ONLY : nqtot, ttext
+       use com_io_dyn_mod, only : histid,histvid,histuid,               &
+     &                        dynhist_file,dynhistv_file,dynhistu_file
 
       implicit none
@@ -31,7 +32,4 @@
 C      nq: nombre de traceurs
 C
-C   Sortie:
-C      fileid: ID du fichier netcdf cree
-C      filevid:ID du fichier netcdf pour la grille v
 C
 C   L. Fairhead, LMD, 03/99
@@ -54,8 +52,6 @@
 C   Arguments
 C
-      character*(*) infile
       integer day0, anne0
       real tstep, t_ops, t_wrt
-      integer fileid, filevid
 
 #ifdef CPP_IOIPSL
@@ -83,4 +79,8 @@
       tau0 = itau_dyn
       
+! -------------------------------------------------------------
+! Creation des 3 fichiers pour les grilles horizontales U,V,Scal
+! -------------------------------------------------------------
+!Grille U      
       do jj = 1, jjp1
         do ii = 1, iip1
@@ -90,12 +90,9 @@
       enddo
        
-      call histbeg(infile, iip1, rlong(:,1), jjp1, rlat(1,:),
+      call histbeg(dynhistu_file, iip1, rlong(:,1), jjp1, rlat(1,:),
      .             1, iip1, 1, jjp1,
-     .             tau0, zjulian, tstep, uhoriid, fileid)
-C
-C  Creation du fichier histoire pour la grille en V (oblige pour l'instant,
-C  IOIPSL ne permet pas de grilles avec des nombres de point differents dans 
-C  un meme fichier)
+     .             tau0, zjulian, tstep, uhoriid, histuid)
 
+! Grille V
       do jj = 1, jjm
         do ii = 1, iip1
@@ -105,10 +102,9 @@
       enddo
 
-      call histbeg('dyn_histv.nc', iip1, rlong(:,1), jjm, rlat(1,:),
+      call histbeg(dynhistv_file, iip1, rlong(:,1), jjm, rlat(1,:),
      .             1, iip1, 1, jjm,
-     .             tau0, zjulian, tstep, vhoriid, filevid)
-C
-C  Appel a histhori pour rajouter les autres grilles horizontales
-C
+     .             tau0, zjulian, tstep, vhoriid, histvid)
+
+!Grille Scalaire
       do jj = 1, jjp1
         do ii = 1, iip1
@@ -118,20 +114,24 @@
       enddo
 
-      call histhori(fileid, iip1, rlong, jjp1, rlat, 'scalar',
-     .              'Grille points scalaires', thoriid)
+      call histbeg(dynhist_file, iip1, rlong(:,1), jjp1, rlat(1,:),
+     .             1, iip1, 1, jjp1,
+     .             tau0, zjulian, tstep, thoriid, histid)
+! -------------------------------------------------------------
+C  Appel a histvert pour la grille verticale
+! -------------------------------------------------------------
+      call histvert(histid, 'presnivs', 'Niveaux pression','mb',
+     .              llm, presnivs/100., zvertiid,'down')
+      call histvert(histvid, 'presnivs', 'Niveaux pression','mb',
+     .              llm, presnivs/100., zvertiid,'down')
+      call histvert(histuid, 'presnivs', 'Niveaux pression','mb',
+     .              llm, presnivs/100., zvertiid,'down')
 C
-C  Appel a histvert pour la grille verticale
-C
-      call histvert(fileid, 'sig_s', 'Niveaux sigma','-',
-     .              llm, nivsigs, zvertiid)
-C Pour le fichier V
-      call histvert(filevid, 'sig_s', 'Niveaux sigma','-',
-     .              llm, nivsigs, zvertiid)
-C
+! -------------------------------------------------------------
 C  Appels a histdef pour la definition des variables a sauvegarder
+! -------------------------------------------------------------
 C
 C  Vents U
 C
-      call histdef(fileid, 'ucov', 'vents u covariants', 'm/s',
+      call histdef(histuid, 'u', 'vent u', 'm/s',
      .             iip1, jjp1, uhoriid, llm, 1, llm, zvertiid,
      .             32, 'inst(X)', t_ops, t_wrt)
@@ -139,5 +139,5 @@
 C  Vents V
 C
-      call histdef(filevid, 'vcov', 'vents v covariants', 'm/s',
+      call histdef(histvid, 'v', 'vent v', 'm/s',
      .             iip1, jjm, vhoriid, llm, 1, llm, zvertiid,
      .             32, 'inst(X)', t_ops, t_wrt)
@@ -146,5 +146,5 @@
 C  Temperature potentielle
 C
-      call histdef(fileid, 'teta', 'temperature potentielle', '-',
+      call histdef(histid, 'teta', 'temperature potentielle', '-',
      .             iip1, jjp1, thoriid, llm, 1, llm, zvertiid,
      .             32, 'inst(X)', t_ops, t_wrt)
@@ -152,5 +152,5 @@
 C  Geopotentiel
 C
-      call histdef(fileid, 'phi', 'geopotentiel instantane', '-',
+      call histdef(histid, 'phi', 'geopotentiel', '-',
      .             iip1, jjp1, thoriid, llm, 1, llm, zvertiid,
      .             32, 'inst(X)', t_ops, t_wrt)
@@ -158,32 +158,34 @@
 C  Traceurs
 C
-        DO iq=1,nqtot
-          call histdef(fileid, ttext(iq),  ttext(iq), '-',
-     .             iip1, jjp1, thoriid, llm, 1, llm, zvertiid,
-     .             32, 'inst(X)', t_ops, t_wrt)
-        enddo
-C
+!
+!        DO iq=1,nqtot
+!          call histdef(histid, ttext(iq),  ttext(iq), '-',
+!     .             iip1, jjp1, thoriid, llm, 1, llm, zvertiid,
+!     .             32, 'inst(X)', t_ops, t_wrt)
+!        enddo
+!C
 C  Masse
 C
-      call histdef(fileid, 'masse', 'masse', 'kg',
-     .             iip1, jjp1, thoriid, 1, 1, 1, -99,
+      call histdef(histid, 'masse', 'masse', 'kg',
+     .             iip1, jjp1, thoriid, llm, 1, llm, zvertiid,
      .             32, 'inst(X)', t_ops, t_wrt)
 C
 C  Pression au sol
 C
-      call histdef(fileid, 'ps', 'pression naturelle au sol', 'Pa',
+      call histdef(histid, 'ps', 'pression naturelle au sol', 'Pa',
      .             iip1, jjp1, thoriid, 1, 1, 1, -99,
      .             32, 'inst(X)', t_ops, t_wrt)
 C
-C  Pression au sol
-C
-      call histdef(fileid, 'phis', 'geopotentiel au sol', '-',
-     .             iip1, jjp1, thoriid, 1, 1, 1, -99,
-     .             32, 'inst(X)', t_ops, t_wrt)
-C
+C  Geopotentiel au sol
+!C
+!      call histdef(histid, 'phis', 'geopotentiel au sol', '-',
+!     .             iip1, jjp1, thoriid, 1, 1, 1, -99,
+!     .             32, 'inst(X)', t_ops, t_wrt)
+!C
 C  Fin
 C
-      call histend(fileid)
-      call histend(filevid)
+      call histend(histid)
+      call histend(histuid)
+      call histend(histvid)
 #else
 ! tell the user this routine should be run with ioipsl
Index: /LMDZ4/trunk/libf/bibio/writedynav.F
===================================================================
--- /LMDZ4/trunk/libf/bibio/writedynav.F	(revision 1402)
+++ /LMDZ4/trunk/libf/bibio/writedynav.F	(revision 1403)
@@ -2,6 +2,6 @@
 ! $Id$
 !
-      subroutine writedynav( histid, time, vcov, 
-     ,                          ucov,teta,ppk,phi,q,masse,ps,phis)
+      subroutine writedynav(time, vcov, 
+     ,                ucov,teta,ppk,phi,q,masse,ps,phis)
 
 #ifdef CPP_IOIPSL
@@ -9,4 +9,5 @@
 #endif
       USE infotrac, ONLY : nqtot, ttext
+      use com_io_dyn_mod, only : histaveid,histvaveid,histuaveid
       implicit none
 
@@ -17,5 +18,4 @@
 C
 C   Entree:
-C      histid: ID du fichier histoire
 C      time: temps de l'ecriture
 C      vcov: vents v covariants
@@ -29,6 +29,4 @@
 C      
 C
-C   Sortie:
-C      fileid: ID du fichier netcdf cree
 C
 C   L. Fairhead, LMD, 03/99
@@ -53,7 +51,6 @@
 C
 
-      INTEGER histid
       REAL vcov(ip1jm,llm),ucov(ip1jmp1,llm) 
-      REAL teta(ip1jmp1*llm),phi(ip1jmp1,llm),ppk(ip1jmp1*llm)                  
+      REAL teta(ip1jmp1*llm),phi(ip1jmp1,llm),ppk(ip1jmp1*llm)     
       REAL ps(ip1jmp1),masse(ip1jmp1,llm)                   
       REAL phis(ip1jmp1)                  
@@ -66,6 +63,6 @@
 C   Variables locales
 C
-      integer ndex2d(iip1*jjp1),ndex3d(iip1*jjp1*llm),iq, ii, ll
-      real us(ip1jmp1*llm), vs(ip1jmp1*llm)
+      integer ndex2d(ip1jmp1),ndexu(ip1jmp1*llm),ndexv(ip1jm*llm)
+      INTEGER iq, ii, ll
       real tm(ip1jmp1*llm)
       REAL vnat(ip1jm,llm),unat(ip1jmp1,llm) 
@@ -75,9 +72,8 @@
 C  Initialisations
 C
-      ndex3d = 0
+      ndexu = 0
+      ndexv = 0
       ndex2d = 0
       ok_sync = .TRUE.
-      us = 999.999
-      vs = 999.999
       tm = 999.999
       vnat = 999.999
@@ -91,20 +87,18 @@
 C  Appels a histwrite pour l'ecriture des variables a sauvegarder
 C
-C  Vents U scalaire
+C  Vents U 
 C
-      call gr_u_scal(llm, unat, us)
-      call histwrite(histid, 'u', itau_w, us, 
-     .               iip1*jjp1*llm, ndex3d)
+      call histwrite(histuaveid, 'u', itau_w, unat, 
+     .               iip1*jjp1*llm, ndexu)
 C
-C  Vents V scalaire
+C  Vents V
 C
-      call gr_v_scal(llm, vnat, vs)
-      call histwrite(histid, 'v', itau_w, vs, 
-     .               iip1*jjp1*llm, ndex3d)
+      call histwrite(histvaveid, 'v', itau_w, vnat, 
+     .               iip1*jjm*llm, ndexv)
 C
 C  Temperature potentielle moyennee
 C
-      call histwrite(histid, 'theta', itau_w, teta, 
-     .                iip1*jjp1*llm, ndex3d)
+      call histwrite(histaveid, 'theta', itau_w, teta, 
+     .                iip1*jjp1*llm, ndexu)
 C
 C  Temperature moyennee
@@ -113,34 +107,39 @@
         tm(ii) = teta(ii) * ppk(ii)/cpp
       enddo
-      call histwrite(histid, 'temp', itau_w, tm, 
-     .                iip1*jjp1*llm, ndex3d)
+      call histwrite(histaveid, 'temp', itau_w, tm, 
+     .                iip1*jjp1*llm, ndexu)
 C
 C  Geopotentiel
 C
-      call histwrite(histid, 'phi', itau_w, phi, 
-     .                iip1*jjp1*llm, ndex3d)
+      call histwrite(histaveid, 'phi', itau_w, phi, 
+     .                iip1*jjp1*llm, ndexu)
 C
 C  Traceurs
 C
-        DO iq=1,nqtot
-          call histwrite(histid, ttext(iq), itau_w, q(:,:,iq), 
-     .                   iip1*jjp1*llm, ndex3d)
-        enddo
+!        DO iq=1,nqtot
+!          call histwrite(histaveid, ttext(iq), itau_w, q(:,:,iq), 
+!     .                   iip1*jjp1*llm, ndexu)
+!        enddo
 C
 C  Masse
 C
-       call histwrite(histid, 'masse', itau_w, masse, iip1*jjp1, ndex2d)
+       call histwrite(histaveid, 'masse', itau_w, masse, 
+     $                   iip1*jjp1*llm, ndexu)
 C
 C  Pression au sol
 C
-       call histwrite(histid, 'ps', itau_w, ps, iip1*jjp1, ndex2d)
+       call histwrite(histaveid, 'ps', itau_w, ps, iip1*jjp1, ndex2d)
 C
 C  Geopotentiel au sol
 C
-       call histwrite(histid, 'phis', itau_w, phis, iip1*jjp1, ndex2d)
+!       call histwrite(histaveid,'phis',itau_w, phis,iip1*jjp1, ndex2d)
 C
 C  Fin
 C
-      if (ok_sync) call histsync(histid)
+      if (ok_sync) then
+          call histsync(histaveid)
+          call histsync(histvaveid)
+          call histsync(histuaveid)
+      ENDIF
 
 #else
Index: /LMDZ4/trunk/libf/bibio/writehist.F
===================================================================
--- /LMDZ4/trunk/libf/bibio/writehist.F	(revision 1402)
+++ /LMDZ4/trunk/libf/bibio/writehist.F	(revision 1403)
@@ -2,6 +2,5 @@
 ! $Id$
 !
-      subroutine writehist( histid, histvid, time, vcov, 
-     ,                          ucov,teta,phi,q,masse,ps,phis)
+      subroutine writehist(time,vcov,ucov,teta,phi,q,masse,ps,phis)
 
 #ifdef CPP_IOIPSL
@@ -9,4 +8,5 @@
 #endif
       USE infotrac, ONLY : nqtot, ttext
+      use com_io_dyn_mod, only : histid,histvid,histuid
       implicit none
 
@@ -17,6 +17,4 @@
 C
 C   Entree:
-C      histid: ID du fichier histoire
-C      histvid:ID du fichier histoire pour les vents V (appele a disparaitre)
 C      time: temps de l'ecriture
 C      vcov: vents v covariants
@@ -29,7 +27,4 @@
 C      phis : geopotentiel au sol
 C      
-C
-C   Sortie:
-C      fileid: ID du fichier netcdf cree
 C
 C   L. Fairhead, LMD, 03/99
@@ -54,5 +49,4 @@
 C
 
-      INTEGER histid, histvid
       REAL vcov(ip1jm,llm),ucov(ip1jmp1,llm) 
       REAL teta(ip1jmp1,llm),phi(ip1jmp1,llm)                   
@@ -71,4 +65,6 @@
       logical ok_sync
       integer itau_w
+      REAL vnat(ip1jm,llm),unat(ip1jmp1,llm)
+
 C
 C  Initialisations
@@ -79,4 +75,6 @@
       ok_sync =.TRUE.
       itau_w = itau_dyn + time
+!  Passage aux composantes naturelles du vent
+      call covnat(llm, ucov, vcov, unat, vnat)
 C
 C  Appels a histwrite pour l'ecriture des variables a sauvegarder
@@ -84,11 +82,10 @@
 C  Vents U
 C
-      call histwrite(histid, 'ucov', itau_w, ucov, 
+      call histwrite(histuid, 'u', itau_w, unat, 
      .               iip1*jjp1*llm, ndexu)
-
 C
 C  Vents V
 C
-      call histwrite(histvid, 'vcov', itau_w, vcov, 
+      call histwrite(histvid, 'v', itau_w, vnat, 
      .               iip1*jjm*llm, ndexv)
 
@@ -106,12 +103,12 @@
 C  Traceurs
 C
-        DO iq=1,nqtot
-          call histwrite(histid, ttext(iq), itau_w, q(:,:,iq), 
-     .                   iip1*jjp1*llm, ndexu)
-        enddo
-C
+!        DO iq=1,nqtot
+!          call histwrite(histid, ttext(iq), itau_w, q(:,:,iq), 
+!     .                   iip1*jjp1*llm, ndexu)
+!        enddo
+!C
 C  Masse
 C
-      call histwrite(histid, 'masse', itau_w, masse, iip1*jjp1, ndex2d)
+      call histwrite(histid,'masse',itau_w, masse,iip1*jjp1*llm,ndexu)
 C
 C  Pression au sol
@@ -121,5 +118,5 @@
 C  Geopotentiel au sol
 C
-      call histwrite(histid, 'phis', itau_w, phis, iip1*jjp1, ndex2d)
+!      call histwrite(histid, 'phis', itau_w, phis, iip1*jjp1, ndex2d)
 C
 C  Fin
@@ -128,4 +125,5 @@
         call histsync(histid)
         call histsync(histvid)
+        call histsync(histuid)
       endif
 #else
Index: /LMDZ4/trunk/libf/dyn3d/adaptdt.F
===================================================================
--- /LMDZ4/trunk/libf/dyn3d/adaptdt.F	(revision 1402)
+++ /LMDZ4/trunk/libf/dyn3d/adaptdt.F	(revision 1403)
@@ -1,8 +1,9 @@
 !
-! $Header$
+! $Id$
 !
       subroutine adaptdt(nadv,dtbon,n,pbaru,
      c                   masse)
 
+      USE control_mod
       IMPLICIT NONE
 
@@ -16,5 +17,4 @@
 #include "logic.h"
 #include "temps.h"
-#include "control.h"
 #include "ener.h"
 #include "description.h"
Index: /LMDZ4/trunk/libf/dyn3d/advtrac.F
===================================================================
--- /LMDZ4/trunk/libf/dyn3d/advtrac.F	(revision 1402)
+++ /LMDZ4/trunk/libf/dyn3d/advtrac.F	(revision 1403)
@@ -16,4 +16,6 @@
 c
       USE infotrac
+      USE control_mod
+ 
 
       IMPLICIT NONE
@@ -27,5 +29,4 @@
 #include "logic.h"
 #include "temps.h"
-#include "control.h"
 #include "ener.h"
 #include "description.h"
@@ -121,5 +122,5 @@
 
       ! ... Flux de masse diaganostiques traceurs
-      flxw = wg / FLOAT(iapp_tracvl)
+      flxw = wg / REAL(iapp_tracvl)
 
 c  test sur l'eventuelle creation de valeurs negatives de la masse
Index: /LMDZ4/trunk/libf/dyn3d/bilan_dyn.F
===================================================================
--- /LMDZ4/trunk/libf/dyn3d/bilan_dyn.F	(revision 1402)
+++ /LMDZ4/trunk/libf/dyn3d/bilan_dyn.F	(revision 1403)
@@ -423,5 +423,5 @@
          Q_cum(:,:,:,iQ)=Q_cum(:,:,:,iQ)/masse_cum(:,:,:)
       enddo
-      zz=1./float(ncum)
+      zz=1./REAL(ncum)
       ps_cum=ps_cum*zz
       masse_cum=masse_cum*zz
Index: /LMDZ4/trunk/libf/dyn3d/caladvtrac.F
===================================================================
--- /LMDZ4/trunk/libf/dyn3d/caladvtrac.F	(revision 1402)
+++ /LMDZ4/trunk/libf/dyn3d/caladvtrac.F	(revision 1403)
@@ -1,4 +1,4 @@
 !
-! $Header$
+! $Id$
 !
 c
@@ -9,4 +9,6 @@
 c
       USE infotrac
+      USE control_mod
+ 
       IMPLICIT NONE
 c
@@ -24,5 +26,4 @@
 #include "paramet.h"
 #include "comconst.h"
-#include "control.h"
 
 c   Arguments:
Index: /LMDZ4/trunk/libf/dyn3d/calfis.F
===================================================================
--- /LMDZ4/trunk/libf/dyn3d/calfis.F	(revision 1402)
+++ /LMDZ4/trunk/libf/dyn3d/calfis.F	(revision 1403)
@@ -31,4 +31,6 @@
 c   .........
       USE infotrac
+      USE control_mod
+ 
 
       IMPLICIT NONE
@@ -96,5 +98,5 @@
 #include "comvert.h"
 #include "comgeom2.h"
-#include "control.h"
+#include "iniprint.h"
 
 c    Arguments :
@@ -149,4 +151,10 @@
       REAL zdpsrf(ngridmx)
 c
+      REAL zdufic(ngridmx,llm),zdvfic(ngridmx,llm)
+      REAL zdtfic(ngridmx,llm),zdqfic(ngridmx,llm,nqtot)
+      REAL jH_cur_split,zdt_split
+      LOGICAL debut_split,lafin_split
+      INTEGER isplit
+
       REAL zsin(iim),zcos(iim),z1(iim)
       REAL zsinbis(iim),zcosbis(iim),z1bis(iim)
@@ -181,8 +189,9 @@
         debut = .TRUE.
         IF (ngridmx.NE.2+(jjm-1)*iim) THEN
-         PRINT*,'STOP dans calfis'
-         PRINT*,'La dimension ngridmx doit etre egale a 2 + (jjm-1)*iim'
-         PRINT*,'  ngridmx  jjm   iim   '
-         PRINT*,ngridmx,jjm,iim
+         write(lunout,*) 'STOP dans calfis'
+         write(lunout,*)
+     &   'La dimension ngridmx doit etre egale a 2 + (jjm-1)*iim'
+         write(lunout,*) '  ngridmx  jjm   iim   '
+         write(lunout,*) ngridmx,jjm,iim
          STOP
         ENDIF
@@ -308,7 +317,7 @@
       CALL gr_dyn_fi(1,iip1,jjp1,ngridmx,pphis,zphis)
       DO l=1,llm
-	 DO ig=1,ngridmx
-	   zphi(ig,l)=zphi(ig,l)-zphis(ig)
-	 ENDDO
+         DO ig=1,ngridmx
+           zphi(ig,l)=zphi(ig,l)-zphis(ig)
+         ENDDO
       ENDDO
 
@@ -408,5 +417,5 @@
             z1(i)   =(rlonu(i)-rlonu(i-1))*pvcov(i,jjm,l)/cv(i,jjm)
             z1bis(i)=(rlonu(i)-rlonu(i-1))*pdvcov(i,jjm,l)/cv(i,jjm)
-	 ENDDO
+         ENDDO
 
          DO i=1,iim
@@ -415,5 +424,5 @@
             zsin(i)    = SIN(rlonv(i))*z1(i)
             zsinbis(i) = SIN(rlonv(i))*z1bis(i)
-	 ENDDO
+         ENDDO
 
          zufi(ngridmx,l)  = SSUM(iim,zcos,1)/pi
@@ -443,11 +452,25 @@
       if (planet_type=="earth") then
 #ifdef CPP_EARTH
-      CALL physiq (ngridmx,
+
+      write(lunout,*) 'PHYSIQUE AVEC NSPLIT_PHYS=',nsplit_phys
+      zdt_split=dtphys/nsplit_phys
+      zdufic(:,:)=0.
+      zdvfic(:,:)=0.
+      zdtfic(:,:)=0.
+      zdqfic(:,:,:)=0.
+
+      do isplit=1,nsplit_phys
+
+         jH_cur_split=jH_cur+(isplit-1) * dtvr / (daysec *nsplit_phys)
+         debut_split=debut.and.isplit==1
+         lafin_split=lafin.and.isplit==nsplit_phys
+
+         CALL physiq (ngridmx,
      .             llm,
-     .             debut,
-     .             lafin,
+     .             debut_split,
+     .             lafin_split,
      .             jD_cur,
-     .             jH_cur,
-     .             dtphys,
+     .             jH_cur_split,
+     .             zdt_split,
      .             zplev,
      .             zplay,
@@ -469,4 +492,21 @@
      .             pducov,
      .             PVteta)
+
+         zufi(:,:)=zufi(:,:)+zdufi(:,:)*zdt_split
+         zvfi(:,:)=zvfi(:,:)+zdvfi(:,:)*zdt_split
+         ztfi(:,:)=ztfi(:,:)+zdtfi(:,:)*zdt_split
+         zqfi(:,:,:)=zqfi(:,:,:)+zdqfi(:,:,:)*zdt_split
+
+         zdufic(:,:)=zdufic(:,:)+zdufi(:,:)
+         zdvfic(:,:)=zdvfic(:,:)+zdvfi(:,:)
+         zdtfic(:,:)=zdtfic(:,:)+zdtfi(:,:)
+         zdqfic(:,:,:)=zdqfic(:,:,:)+zdqfi(:,:,:)
+
+      enddo
+      zdufi(:,:)=zdufic(:,:)/nsplit_phys
+      zdvfi(:,:)=zdvfic(:,:)/nsplit_phys
+      zdtfi(:,:)=zdtfic(:,:)/nsplit_phys
+      zdqfi(:,:,:)=zdqfic(:,:,:)/nsplit_phys
+
 #endif
       endif !of if (planet_type=="earth")
Index: /LMDZ4/trunk/libf/dyn3d/ce0l.F90
===================================================================
--- /LMDZ4/trunk/libf/dyn3d/ce0l.F90	(revision 1402)
+++ /LMDZ4/trunk/libf/dyn3d/ce0l.F90	(revision 1403)
@@ -14,4 +14,5 @@
 !     masque is created in etat0, passed to limit to ensure consistancy.
 !-------------------------------------------------------------------------------
+  USE control_mod
 #ifdef CPP_EARTH
 ! This prog. is designed to work for Earth
@@ -36,5 +37,4 @@
 #include "indicesol.h"
 #include "iniprint.h"
-#include "control.h"
 #include "temps.h"
 #include "logic.h"
Index: /LMDZ4/trunk/libf/dyn3d/com_io_dyn_mod.F90
===================================================================
--- /LMDZ4/trunk/libf/dyn3d/com_io_dyn_mod.F90	(revision 1403)
+++ /LMDZ4/trunk/libf/dyn3d/com_io_dyn_mod.F90	(revision 1403)
@@ -0,0 +1,31 @@
+!
+! $Id $
+!
+module com_io_dyn_mod
+
+  implicit none 
+
+! Names of various files for outputs (in the dynamics)
+  ! to store instantaneous values:
+  character(len=18),parameter :: dynhist_file="dyn_hist.nc" ! on scalar grid
+  character(len=18),parameter :: dynhistv_file="dyn_histv.nc" ! on v grid
+  character(len=18),parameter :: dynhistu_file="dyn_histu.nc" ! on u grid
+
+  ! to store averaged values:
+  character(len=18),parameter :: dynhistave_file="dyn_hist_ave.nc"
+  character(len=18),parameter :: dynhistvave_file="dyn_histv_ave.nc"
+  character(len=18),parameter :: dynhistuave_file="dyn_histu_ave.nc"
+  
+! Ids of various files for outputs (in the dynamics)
+
+  ! instantaneous (these are set by inithist.F)
+  integer :: histid
+  integer :: histvid
+  integer :: histuid
+  
+  ! averages (these are set by initdynav.F)
+  integer :: histaveid
+  integer :: histvaveid
+  integer :: histuaveid
+  
+end module com_io_dyn_mod
